unit Mainm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, uniGUITypes, uniGUIAbstractClasses,
  uniGUIClasses, uniGUImClasses, uniGUIRegClasses, uniGUIForm, uniGUImForm, uniGUImJSForm, uniGUIBaseClasses,
  uniFileUpload, unimFileUpload, uniButton, uniCanvas, unimButton, uniImage, unimImage, Vcl.Imaging.jpeg, uniPanel,
  uniHTMLFrame, unimHTMLFrame, uniURLFrame, unimURLFrame, uniMultiItem, unimSelect, unimPanel, RxGIF;

type
  TMainmForm = class(TUnimForm)
    FileUpload: TUnimFileUpload;
    ButtonPanel: TUnimContainerPanel;
    FastTest: TUnimButton;
    UploadTest: TUnimButton;
    ColorSelect: TUnimSelect;
    DoExport: TUnimButton;
    Panel1: TUnimPanel;
    ImgPanel: TUnimContainerPanel;
    Panel2: TUnimPanel;
    OutImage: TUnimImage;
    procedure FastTestClick(Sender: TObject);
    procedure FileUploadCompleted(Sender: TObject; AStream: TFileStream);
    procedure UploadTestClick(Sender: TObject);
    procedure DoExportClick(Sender: TObject);
    procedure ImgPanelAjaxEvent(Sender: TComponent; EventName: string; Params: TUniStrings);
  private
  public
    procedure InitAnnotate(FileName: string);
  end;

function MainmForm: TMainmForm;

var
  Directory  : string;   // Path to Application Directory

implementation

{$R *.dfm}

uses
  uniGUIVars, MainModule, uniGUIApplication, IdCoderMIME;

function MainmForm: TMainmForm;
begin
  Result := TMainmForm(UniMainModule.GetFormInstance(TMainmForm));
end;

procedure TMainmForm.ImgPanelAjaxEvent(Sender: TComponent; EventName: string; Params: TUniStrings);
var
  Decoder : TIdDecoderMIME;
  Str     : TMemoryStream;
  Buff    : string;
  Jpg     : TJPEGImage;
begin
  if EventName='SendImage' then begin
    Decoder:=TIdDecoderMIME.Create(nil);
    Str:=TMemoryStream.Create;
    try
      Buff:=Params.Values['image'];
      Buff:=Copy(Buff,Pos(',',Buff)+1,Length(Buff));
      Decoder.DecodeStream(Buff,Str);

      Str.Position:=0;
      Jpg:=TJPEGImage.Create;
      Jpg.LoadFromStream(Str);

      OutImage.Picture.Assign(Jpg);
    finally
      Decoder.Free;
      Str.Free;
    end;
  end;
end;

procedure TMainmForm.FastTestClick(Sender: TObject);
begin
  FileUpload.Execute;
end;

procedure TMainmForm.UploadTestClick(Sender: TObject);
begin
  InitAnnotate('test.jpg');
end;

procedure TMainmForm.FileUploadCompleted(Sender: TObject; AStream: TFileStream);
var
  f        : File;
  Bytes    : TBytes;
  GUID     : TGUID;
  FileName : string;
begin
  if CreateGUID(GUID)<>S_OK then begin
    raise Exception.Create('Can not create GUID');
  end;
  FileName:=GUID.ToString+'.jpg';

  SetLength(Bytes,AStream.Size);
  AStream.ReadBuffer(Bytes[0],AStream.Size);
  ForceDirectories(Directory+'files\images\');
  AssignFile(f,Directory+'files\images\'+FileName);
  Rewrite(f,1);
  BlockWrite(f,Bytes[0],length(Bytes));
  CloseFile(f);

  InitAnnotate(FileName);
end;

procedure TMainmForm.InitAnnotate(FileName: string);
var
  Jpg: TJPEGImage;
begin
  Jpg:=TJPEGImage.Create;
  Jpg.LoadFromFile(Directory+'\files\images\'+FileName);
  Panel1.Height:=Jpg.Height+ImgPanel.Margins.Top+ImgPanel.Margins.Bottom;
  Jpg.Free;
  UniSession.AddJS('startAnnotate("'+FileName+'","'+ColorSelect.Text+'");');

  FastTest.Enabled:=False;
  UploadTest.Enabled:=False;
  ColorSelect.Visible:=False;
end;

procedure TMainmForm.DoExportClick(Sender: TObject);
begin
  UniSession.AddJS('exportAnnotate();');
end;

function GetModuleFileNameStr(Instance: THandle): string;
var
  buffer: array [0..MAX_PATH] of Char;
begin
  GetModuleFileName( Instance, buffer, MAX_PATH);
  Result := buffer;
  Result:=StringReplace(Result,'\\?\','',[]);
end;

initialization
  RegisterAppFormClass(TMainmForm);
  Directory:=ExtractFilePath(GetModuleFileNameStr(Hinstance));

end.

